class ReferenciasController < ApplicationController
  
  include AuthenticatedSystem
  before_filter :login_required, :except => %w[index show VerReferenciaComum ListarReferenciasComum ListarReferenciasPublico filtrar_por_tamanho filtrar_por_ordem_alfabetica VerReferenciaPublico] #Acesso permitido s com login
  
  #Tela de insero de referncias
  #Campos: (buscar vias, nome e nmero de referncia, mapa com boto de atualizao)
  def ReferenciaPrivado
    @logged = logged_in?
    @referencias = Referencia.find(:all)
    @referencia = Referencia.new
    render :action => "ReferenciaPrivado"
  end
  
  def VerReferenciaComum
    @logged = logged_in?
    @referencia = Referencia.find_by_id(params[:id])
    @referencia.marcar_acesso
    
    render :action=> "VerReferenciaComum"
  end
 
  def index
    @logged = logged_in?
    self.filtrar_por_tamanho
  end
  
  #Cria uma nova Referencia e a guarda em @busca para us-la em JavaScript
  #como campo encondido
  def create
    @logged = logged_in?
    @referencia = Referencia.new(params[:referencia])
    @referencia.save
    @busca = @referencia[:nome]
      
    self.ReferenciaPrivado
  end

  #Atualiza as informaes de uma referncia
  def update
    @logged = logged_in?
    @referencia = Referencia.find(params[:id])
    @referencia.update_attributes(params[:referencia])
    @busca = @referencia[:nome]
    
    self.atribuir_campos
       
  end
  
  
  def delete
    @logged = logged_in?
    @referencia = Referencia.find(params[:id])
    if @referencia.destroy
      @message = 'Referencia removida com sucesso.'
    else
      @message = 'A referencia no foi removida.'
    end
    
    flash[:notice] = 'Referencia was successfully deleted.'
    respond_to do |format|
      format.html { redirect_to("/referencias") }
      format.xml  { head :ok }
    end
  end
  

  #Remove uma referncia
  def destroy
    @logged = logged_in?
    @referencia = Referencia.find(params[:id])
    if @referencia.destroy
      @message = 'Referencia removida com sucesso.'
    else
      @message = 'A referencia no foi removida.'
    end

    self.voltar_com_historico
  end
  
  #Busca por uma via na tela de insero de referncias 
  #(para associar uma referncia a uma via)
  def buscar
        @logged = logged_in?
        @parametro_busca = params[:parametro]
        @resultado_busca = Via.find(:all, :conditions =>['nome LIKE ? or apelido LIKE ?' , '%'+@parametro_busca+'%','%'+@parametro_busca+'%'], :order => "nome ASC" )
        
        if @resultado_busca.empty?
          @message = 'Nenhuma referencia encontrada.'
        end
        
        self.ListarVias
  end
  
  def ListarVias
    render :action => "ListarVias"
  end
  
  #Busca por uma via na tela de edio de referncias
  #(Os resultados aparecem na mesma tela de edio)
  def buscar_edicao
        @logged = logged_in?
        @parametro_busca = params[:parametro] #parmetro de busca de vias
        session[:historico_vias_pesquisadas] = params[:parametro] #guarda o parmetro de busca de vias de edio
        @resultado_busca = Via.find(:all, :conditions =>['nome LIKE ? or apelido LIKE ?' , '%'+@parametro_busca+'%','%'+@parametro_busca+'%'], :order => "nome ASC" ) #pega os resultados da busca no BD
        @referencia = Referencia.find(session[:historico_referencia_editar]) #Recupera a referncia que se est editando para continuar a mostr-la na tela
        @resultado_busca_referencia = Referencia.find(:all, :conditions =>['nome LIKE ? or nome LIKE ?' , '%'+session[:historico_busca]+'%','%'+session[:historico_busca]+'%'], :order => "nome ASC" ) #Recupera as referncias mostradas na procura para mostr-las na tela 
        
        if @resultado_busca_referencia.empty?
          @message = 'Nenhuma referencia encontrada.'
        end
        
        self.ReferenciaPrivadoEditar
  end
  
  #Atribui uma via a uma referncia na tela de insero (a via est em um link)
  def atribuir_via
    @logged = logged_in?
    @via = Via.find(params[:id])
    self.ReferenciaPrivado
  end
  
  #Atribui uma via a uma referncia na tela de edio (a via est em um link)
  def atribuir_via_editar
    @logged = logged_in?
    @referencia = Referencia.find(session[:historico_referencia_editar]) #Recupera a referncia em edio
    @resultado_busca = Via.find(:all, :conditions =>['nome LIKE ? or apelido LIKE ?' , '%'+ session[:historico_vias_pesquisadas] +'%','%'+ session[:historico_vias_pesquisadas] +'%'], :order => "nome ASC" ) #Recupera todas as vias buscadas
    
    self.voltar_com_historico
  end
  
  #Volta  tela de edio mantendo o histrico de busca de uma edio
  def voltar_com_historico
    @logged = logged_in?
    @resultado_busca_referencia = Referencia.find(:all, :conditions =>['nome LIKE ? or nome LIKE ?' , '%'+session[:historico_busca]+'%','%'+session[:historico_busca]+'%'], :order => "nome ASC" )#Recupera todas as referncias buscadas
    self.ReferenciaPrivadoEditar
  end
  
  #Redireciona para a tela principal de edio (tela de busca de referncias)
  def ReferenciaPrivadoEditar
    @logged = logged_in?
    render :action => "ReferenciaPrivadoEditar"
  end
  
  #Busca referncias
  def buscar_referencias
    @logged = logged_in?
    @parametro_busca = params[:parametro]
    @resultado_busca_referencia = Referencia.find(:all, :conditions =>['nome LIKE ? or nome LIKE ?' , '%'+@parametro_busca+'%','%'+@parametro_busca+'%'], :order => "nome ASC" )
    session[:historico_busca] = @parametro_busca #guarda o parmetro de busca
    
    if @resultado_busca_referencia.empty?
       @message = 'Nenhuma referencia encontrada.'
    end
    
    self.ReferenciaPrivado
  end
  
  def buscar_referencias_editar
    @logged = logged_in?
    @parametro_busca = params[:parametro]
    @resultado_busca_referencia = Referencia.find(:all, :conditions =>['nome LIKE ? or nome LIKE ?' , '%'+@parametro_busca+'%','%'+@parametro_busca+'%'], :order => "nome ASC" )
    session[:historico_busca] = @parametro_busca #guarda o parmetro de busca
    
    if @resultado_busca_referencia.empty?
       @message = 'Nenhuma referencia encontrada.'
    end
    
    self.ReferenciaPrivadoEditar
  end
  
  #Preenche os campos de edio com os valores atuais da referncia a ser editada
  def atribuir_campos
    @logged = logged_in?
    @referencia = Referencia.find(params[:id])
    session[:historico_referencia_editar] = params[:id] #Guarda o parmetro da referncia em edio
    self.voltar_com_historico
  end
  
  #Filtrar por ordem alfabtica as tags da tela
  def filtrar_por_ordem_alfabetica
    @logged = logged_in?
    @referencias = Referencia.get_cloud_alfabetica
    @referencia = Referencia.new
    self.VerReferenciaPublico
  end

  #Filtrar por tamanho as tags da tela
  def filtrar_por_tamanho
    @logged = logged_in?
    @referencias = Referencia.get_cloud
    @referencia = Referencia.new
    self.VerReferenciaPublico
  end
  
  def VerReferenciaPublico
    @logged = logged_in?
    @referencias = Referencia.get_cloud
    render :action => "VerReferenciaPublico"
  end
  
end
