class ViasController < ApplicationController
  
  include AuthenticatedSystem
  before_filter :login_required, :except => %w[ index show ViaComum PrincipalPublico filtrar_por_tamanho filtrar_por_ordem_alfabetica ViaPublico]
  
  
  
  #Tela de insero de vias 
  def ViaAdmin
    @logged = logged_in?
    @vias = Via.find(:all)
    @via = Via.new
    render :action => "ViaAdmin"
  end
  
  def ViaAdminEditar
    @logged = logged_in?
    render :action => "ViaAdminEditar"
  end
  
  def ViaComum
    @logged = logged_in?
    @via = Via.find params[:id]
    @via.marcar_acesso
    @user = current_user
    @cameras = Array.new
    @via.cameras.each do |cam|
      @cameras << cam.ponto_serttel
    end
  end
  
  #Redirecionamento para a tela de visualizao de vias (Tela principal do site)
  def PrincipalPublico
    @logged = logged_in?
    @vias = Via.get_cloud_alfabetica
    # @situacoes = Via.get_situacoes
    
    render :action => "PrincipalPublico"
  end
  
  
  def index
    @logged = logged_in?
    self.filtrar_por_tamanho
  end
  
  #Edita uma via
  def edit
    @logged = logged_in?
    @via = Via.find params[:id]
    @pontos_via = @via.cameras
    render :action => "ViaAdminEditar"
  end
  
  #Cria uma nova via e a guarda no BD
  def create
    @logged = logged_in?
    @via = Via.new(params[:via])
    if @via.save
      @message = 'Via criada com sucesso.'
    else
      @message = 'Via j inserida ou o formulrio de insero est imcompleto.'
    end
    @busca = @via[:nome]
    
    self.ViaAdmin
  end
  
  #Atualiza uma via
  def update
    @logged = logged_in?
    @via = Via.find(params[:id])
    if @via.update_attributes(params[:via])
      @message = 'Via atualizada com sucesso'
    else
      @message = 'A via no foi atualizada.'
    end
    @busca = @via[:nome]
    
    @via = nil #Seta as vias como nulas para o campo de edio s aparecer quando tiver uma via selecionada.
    self.voltar_com_historico
    
  end
  
  #Remove uma via
  def destroy
    @logged = logged_in?
    @via = Via.find(params[:id])
    
    if @via.destroy
      @message = 'Via removida com sucesso.'
    else
      @message = 'A via no foi removida.'
    end
    
    @via = nil
    
    self.voltar_com_historico
    
  end
  
    #Busca uma via para edit-la (acesso restrito)
    #Redireciona para a tela de edio
    def buscar
      @logged = logged_in?
      @parametro_busca = params[:parametro]
      @resultado_busca = Via.find(:all, :conditions =>['nome LIKE ? or apelido LIKE ?' , '%'+@parametro_busca+'%','%'+@parametro_busca+'%'], :order => "nome ASC" )
      session[:historico_busca] = @parametro_busca #Guarda o parmetro de busca por uma via
    
      if @resultado_busca.empty?
        @message = 'Nenhuma via encontrada.'
      end
    
      self.ViaAdmin
    
    end
  
  def buscar_viaAdminEditar
    @logged = logged_in?
    @parametro_busca = params[:parametro]
    @resultado_busca = Via.find(:all, :conditions =>['nome LIKE ? or apelido LIKE ?' , '%'+@parametro_busca+'%','%'+@parametro_busca+'%'], :order => "nome ASC" )
    session[:historico_busca] = @parametro_busca #Guarda o parmetro de busca por uma via
    
    if @resultado_busca.empty?
      @message = 'Nenhuma via encontrada.'
    end
    
    self.ViaAdminEditar
    
  end
  
  def buscar_adjacencias
    @logged = logged_in?
    @parametro_busca = params[:parametro]
    @resultado_busca = Via.find(:all, :conditions =>['nome LIKE ? or apelido LIKE ?' , '%'+@parametro_busca+'%','%'+@parametro_busca+'%'], :order => "nome ASC" )
    session[:historico_busca] = @parametro_busca #Guarda o parmetro de busca por uma via
    
    if @resultado_busca.empty?
      @message = 'Nenhuma via encontrada.'
    end
    
    self.ViaAdminAdjacencias
  end
  
  def buscar_tela_cameras
    @logged = logged_in?
    @parametro_busca = params[:parametro]
    @resultado_busca = Via.find(:all, :conditions =>['nome LIKE ? or apelido LIKE ?' , '%'+@parametro_busca+'%','%'+@parametro_busca+'%'], :order => "nome ASC" )
    session[:historico_busca] = @parametro_busca #Guarda o parmetro de busca por uma via
    
    if @resultado_busca.empty?
      @message = 'Nenhuma via encontrada.'
    end
    
    self.ViaAdminCameras
  end
  
  def ViaAdminCameras
    @logged = logged_in?
    render :action => "ViaAdminCameras"
  end
  
  def ViaAdminAdjacencias
    @logged = logged_in?
    render :action => "ViaAdminAdjacencias"
  end
  #Busca uma via para visualiz-la (acesso liberado)
  #Redireciona para a tela principal
  def buscar_publico
    @logged = logged_in?
    @parametro_busca = params[:parametro]
    @resultado_busca = Via.find(:all, :conditions =>['nome LIKE ? or apelido LIKE ?' , '%'+@parametro_busca+'%','%'+@parametro_busca+'%'], :order => "nome ASC" )
    
    if @resultado_busca.empty?
      @message = 'Nenhuma via encontrada.'
    end
    
    self.PrincipalPublico
  end
  
  #Listar vias procuradas
  def via_listar
    @logged = logged_in?
    @resultado_total = Via.find(:all, :order => "UPPER(apelido)") #Recupera as vias por ordem alfabtica
    
    valor_inicial = 4*params[:id].to_i - 4
    cont = 0
    @resultado_parcial = Array.new
    
    #Guarda em um array as vias que sero exibidas por pgina
    while((@resultado_total[valor_inicial + cont] != nil) and cont < 4)
      
      @resultado_parcial[cont] = @resultado_total[valor_inicial + cont]
      cont = cont + 1 
      
    end  
    
    render :action => "ViaListar"
  end
  
  #Preencher os campos de edio de uma via
  def atribuir_campos
    @logged = logged_in?
    @via = Via.find(params[:id])
    self.voltar_com_historico
  end
  
  def atribuir_campos_adjacencia
    @logged = logged_in?
    @via = Via.find(params[:id])
    @vias = Via.find(:all, :conditions => ['nome NOT LIKE ?', @via[:nome]], :order => 'nome ASC')
    @adjacentes = Via.get_vias_adjacentes params[:id]
    self.voltar_com_historico_adjacencia
  end
  
  def atribuir_campos_cameras
    @logged = logged_in?
    @via = Via.find(params[:id])
    @todos_pontos = PontoSerttel.find :all
    @pontos_via = @via.cameras
    self.voltar_com_historico_cameras
  end
  
  def voltar_com_historico_cameras
    @logged = logged_in?
    @resultado_busca = Via.find(:all, :conditions =>['nome LIKE ? or apelido LIKE ?' , '%'+session[:historico_busca]+'%','%'+session[:historico_busca]+'%'], :order => "nome ASC" )
    
    self.ViaAdminCameras
  end
  
  def voltar_com_historico_adjacencia
    @logged = logged_in?
    @resultado_busca = Via.find(:all, :conditions =>['nome LIKE ? or apelido LIKE ?' , '%'+session[:historico_busca]+'%','%'+session[:historico_busca]+'%'], :order => "nome ASC" )
    @vias_adjacentes = Via.get_vias_adjacentes params[:id]
    @listagem_adjacentes = ''
    
    @vias_adjacentes.each do |adjacente|
      if @vias_adjacentes.last[:nome] != adjacente[:nome] 
        @listagem_adjacentes = @listagem_adjacentes + adjacente[:nome] + ','  
      else
        @listagem_adjacentes = @listagem_adjacentes + adjacente[:nome]
      end
    end
    
    self.ViaAdminAdjacencias
  end
  
  #Volta  tela de edio mantendo o histrico de busca de uma edio
  def voltar_com_historico
    @logged = logged_in?
    @resultado_busca = Via.find(:all, :conditions =>['nome LIKE ? or apelido LIKE ?' , '%'+session[:historico_busca]+'%','%'+session[:historico_busca]+'%'], :order => "nome ASC" )
    self.ViaAdminEditar
  end
  
  #Define uma ao quando via  acessada (incremento do nmero de acessos)
  def ViaPublico
    @logged = logged_in?
    @via = Via.find_by_id(params[:id])
    @via.marcar_acesso
    
    render :action=> "ViaPublico"
  end
  
  #Filtrar por ordem alfabtica as tags da tela principal
  def filtrar_por_ordem_alfabetica
    @logged = logged_in?
    @vias = Via.get_cloud_alfabetica
    @via = Via.new
    self.PrincipalPublico
  end
  
  #Filtrar por tamanho as tags da tela principal
  def filtrar_por_tamanho
    @logged = logged_in?
    @vias = Via.get_cloud
    @via = Via.new
    self.PrincipalPublico
  end
  
  def filtrar_por_bairro
    @logged = logged_in?
    @vias = Via.get_cloud_bairro(params[:parametro_bairro])
    @via = Via.new
    self.PrincipalPublico
  end
  
  #Filtrar por situao do trfego
  def filtrar_por_situacao
    @logged = logged_in?
    @vias = Via.get_cloud_situacao(params[:parametro_situacao])
    @via = Via.new
    self.PrincipalPublico
  end
  
  def setar_cameras
    @logged = logged_in?
    @via = Via.find params[:id]
    @via.cameras.destroy_all
    params[:camera].each do |id,valor|
      if(valor == "1")
        novaCamera = Camera.new
        novaCamera.id_camera = id
        @via.cameras << novaCamera
      end
    end
    flash[:notice] = "Cameras editadas com sucesso."
    redirect_to :action => "listar_cameras", :id => @via
  end
  
  def listar_cameras
    @logged = logged_in?
    @todos_pontos = PontoSerttel.find :all
    @via = Via.find params[:id]
    @pontos_via = @via.cameras
    redirect_to :action => 'ViaAdmin', :id => @via.id
  end
  
  def imagem_camera
    @logged = logged_in?
    via = Via.find params[:id]
    id_camera = via.cameras[params[:camera].to_i].id_camera
    
    res = Net::HTTP::get_response(URI.parse("http://172.17.69.30:3000/ponto_serttels/imagem/" + id_camera.to_s))
    
    send_data(
              res.body, 
              :type => res['Content-type'],
    :filename => id_camera,
    :disposition => 'inline'
    )
  end
  
  def salvar_favorito
    # UsersController.current_user().favoritos << params[:id]
    favorito = Favorito.new
    favorito.via_id = params[:id]
    favorito.login = current_user[:login]
    favorito.save
    redirect_to :action => 'ViaComum', :id => params[:id]
  end
  
  def inserir_adjacencia
    
    Via.delete_adjacencias params[:id]
    
    params[:adjacente].each do |id,adjacente|
      if adjacente == "1"
        adicionar_adjacencia params[:id], id
      end
    end
    
    self.ViaAdminAdjacencias
  end
  
  def adicionar_adjacencia via_id1, via_id2
    adjacencia = Adjacencia.new
    adjacencia.via_id1 = via_id1
    adjacencia.via_id2 = via_id2
    adjacencia.save
  end
  
  def listar_adjacencias
    @vias = Via.get_vias_adjacentes params[:parametro_adjacencia]
    @via = Via.new
    self.PrincipalComum
  end
  
  def PrincipalComum
    render :action => "PrincipalComum"
  end
  
  
  
end

