Upload = Struct.new('Upload', :original_filename, :content_type, :read)

class Foto < ActiveRecord::Base

  validates_presence_of :filename
  validates_presence_of :user
  validates_uniqueness_of :user

  def self.find_all_images(*arguments)
    arguments[0] = :all if !arguments[0]

    if arguments[1]
      arguments[1][:conditions] = ['mimetype like ?', 'image%']
    else
      arguments[1] = { :conditions => ['mimetype like ?', 'image%'] }
    end

    find(*arguments)
  end

  def image?
    self.mimetype =~ /^image/
  end

  def upload
    Upload.new(self.filename, self.mimetype, self.content)
  end

  def upload=(upload)
    self.filename = upload.original_filename
    self.mimetype = upload.content_type.chomp
    self.content = upload.read
  end

end