class Via < ActiveRecord::Base
  
  has_many :cameras
  has_one :referencia, :dependent => :destroy
  validates_uniqueness_of :nome
  validates_presence_of :nome, :apelido, :bairro, :coordenadaX, :coordenadaY
  
  
  
  attr_accessor :size
  
  def marcar_acesso
    self.contador_acessos = self.contador_acessos  + 1
    
    self.save
  end
  
  
  def self.get_cloud
    vias = Via.find(:all, :limit => 32, :order => "contador_acessos DESC")
    maior_contador = vias.first
    menor_contador = vias.last
    
    vias.each do |via|
        if  maior_contador.contador_acessos - menor_contador.contador_acessos != 0
           via.size = 7 * ((Float(via.contador_acessos - menor_contador.contador_acessos)) /(Float(maior_contador.contador_acessos - menor_contador.contador_acessos)))
        else
           via.size = 3
        end
    end
    
  end
  
  def self.get_cloud_alfabetica
    vias = Via.find(:all, :limit => 40, :order => "contador_acessos DESC")
    maior_contador = vias.first
    menor_contador = vias.last
    vias = Via.find(:all, :limit => 40, :order => "UPPER(apelido)")

    vias.each do |via|
        if  maior_contador.contador_acessos - menor_contador.contador_acessos != 0
           via.size = 7 * ((Float(via.contador_acessos - menor_contador.contador_acessos)) /(Float(maior_contador.contador_acessos - menor_contador.contador_acessos)))
        else
           via.size = 3
        end
    end
    
  end
  
  def self.get_cloud_bairro b
    vias = Via.find(:all, :limit => 40, :conditions => ["UPPER(bairro) = UPPER(?)", b ], :order => "contador_acessos DESC")
    maior_contador = vias.first
    menor_contador = vias.last
    vias = Via.find(:all, :limit => 40, :conditions => ["UPPER(bairro) = UPPER(?)", b ], :order => "UPPER(apelido)")
    
    vias.each do |via|
        if  maior_contador.contador_acessos - menor_contador.contador_acessos != 0
           via.size = 7 * ((Float(via.contador_acessos - menor_contador.contador_acessos)) /(Float(maior_contador.contador_acessos - menor_contador.contador_acessos)))
        else
           via.size = 3
        end
    end
    
  end
  
  def self.get_situacoes
     vias = Via.find(:all, :order => "UPPER(apelido) ASC")
     situacoes = Array.new
     contador = 0
     situacao = ''
     
     vias.each do |via|
      cams = via.cameras
      
      cams.each do |cam|
        ponto = cam.ponto_serttel
        
        if ponto.sit_transito.downcase == 'lento'
          situacao = 'lento'
          break
        elsif ponto.sit_transito.downcase == 'medio'
          situacao = 'medio'
        else
          if situacao != 'medio'
            situacao = 'livre'            
          end
        end
                    
      end
      
      situacoes[contador] = situacao
    
    end
                
  end
  
  def self.get_cloud_situacao situacao
    vias_temp = Array.new
    flag_situacao = false
    contador = 0
        
    vias = Via.find(:all, :order => "UPPER(apelido)")
    
    vias.each do |via|
      cams = via.cameras
      
      cams.each do |cam|
        ponto = cam.ponto_serttel
                
        if ponto.sit_transito.downcase == situacao.downcase
          flag_situacao = true
          break
        end
        
      end
      
      if flag_situacao
        vias_temp[contador] = via
        flag_situacao = false
        contador = contador + 1
      end
      
      if contador > 40
        break
      end
      
    end
    
    if vias_temp.first != nil
      vias_temp.sort! {|a,b| a.contador_acessos <=> b.contador_acessos}
      menor_contador = vias_temp.first
      maior_contador = vias_temp.last
      
      vias_temp.sort! {|a,b| a.apelido.downcase <=> b.apelido.downcase}
     
        
      vias.each do |via|
        if  maior_contador.contador_acessos - menor_contador.contador_acessos != 0
           via.size = 7 * ((Float(via.contador_acessos - menor_contador.contador_acessos)) /(Float(maior_contador.contador_acessos - menor_contador.contador_acessos)))
        else
           via.size = 3
        end
      end
    end
    
    vias = vias_temp
    
  end
  
  def self.get_vias_adjacentes via
    adjacencias = Adjacencia.find(:all);
    vias = Array.new
    contador = 0
    
    adjacencias.each do |adjacencia|
      
     
     if adjacencia.via_id1.to_i == via.to_i
        via_id = adjacencia.via_id2.to_i
        vias[contador] = Via.find(via_id)
        contador = contador + 1
     elsif adjacencia.via_id2.to_i == via.to_i
        via_id = adjacencia.via_id1.to_i
        vias[contador] = Via.find(via_id)
        contador = contador + 1
     end
        
        
      
    end
    vias.sort! {|a,b| a.apelido.downcase <=> b.apelido.downcase}
    
  end
  
  def self.delete_adjacencias via
    adjacencias = Adjacencia.find(:all)
    
    adjacencias.each do |adjacencia|
        if adjacencia.via_id1.to_i == via.to_i
          Adjacencia.delete(adjacencia[:id])
        elsif adjacencia.via_id2.to_i == via.to_i
          Adjacencia.delete(adjacencia[:id])
        end
    end
    
  end
  
end

